package foo;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.api.ExecutionService;

public class CallbackListener {
	
	private final Map<String, String> executionMap = new HashMap<String, String>();
	
	private ExecutionService executionService;

	private static final CallbackListener instance = new CallbackListener();
	
	public static CallbackListener getInstance() {
		return instance;
	}
	
	public void setExecutionService(ExecutionService executionService) {
		this.executionService = executionService;
	}
	
	public synchronized void register(String name, String executionId) {
		executionMap.put(name, executionId);
	}
	
	public synchronized void signal(String name) {
		executionService.signalExecutionById(executionMap.get(name));
	}
}
